- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# cs_instance_nic – Manages NICs of an instance on Apache CloudStack based clouds

New in version 2.4.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Add and remove nic to and from network

## Requirements

The below requirements are needed on the host that executes this module.

- python >= 2.6
- cs >= 0.6.10

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
account string |  | Account the instance is related to.
api_http_method string | Choices: get post | HTTP method used to query the API endpoint. If not given, the `CLOUDSTACK_METHOD` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes. Fallback value is `get` if not specified.
api_key string |  | API key of the CloudStack API. If not given, the `CLOUDSTACK_KEY` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes.
api_region string | Default: "cloudstack" | Name of the ini section in the `cloustack.ini` file. If not given, the `CLOUDSTACK_REGION` env variable is considered.
api_secret string |  | Secret key of the CloudStack API. If not set, the `CLOUDSTACK_SECRET` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes.
api_timeout integer |  | HTTP timeout in seconds. If not given, the `CLOUDSTACK_TIMEOUT` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes. Fallback value is 10 seconds if not specified.
api_url string |  | URL of the CloudStack API e.g. https://cloud.example.com/client/api. If not given, the `CLOUDSTACK_ENDPOINT` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes.
domain string |  | Domain the instance is related to.
ip_address string |  | IP address to be used for the nic.
network string / required |  | Name of the network.
poll_async boolean | Choices: no yes ← | Poll async jobs until job has finished.
project string |  | Name of the project the instance is deployed in.
state string | Choices: present ← absent | State of the nic.
vm string / required |  | Name of instance. aliases: name
vpc string |  | Name of the VPC the vm is related to.
zone string |  | Name of the zone in which the instance is deployed in. If not set, default zone is used.

## Notes

Note

- Ansible uses the `cs` library’s configuration method if credentials are not provided by the arguments `api_url`, `api_key`, `api_secret`. Configuration is read from several locations, in the following order. The `CLOUDSTACK_ENDPOINT`, `CLOUDSTACK_KEY`, `CLOUDSTACK_SECRET` and `CLOUDSTACK_METHOD`. `CLOUDSTACK_TIMEOUT` environment variables. A `CLOUDSTACK_CONFIG` environment variable pointing to an `.ini` file. A `cloudstack.ini` file in the current working directory. A `.cloudstack.ini` file in the users home directory. Optionally multiple credentials and endpoints can be specified using ini sections in `cloudstack.ini`. Use the argument `api_region` to select the section name, default section is `cloudstack`. See https://github.com/exoscale/cs for more information.
- A detailed guide about cloudstack modules can be found in the CloudStack Cloud Guide.
- This module supports check mode.

## Examples

    - name: Add a nic on another network
      cs_instance_nic:
        vm: privnet
        network: privNetForBasicZone
      delegate_to: localhost

    - name: Ensure IP address on a nic
      cs_instance_nic:
        vm: privnet
        ip_address: 10.10.11.32
        network: privNetForBasicZone
      delegate_to: localhost

    - name: Remove a secondary nic
      cs_instance_nic:
        vm: privnet
        state: absent
        network: privNetForBasicZone
      delegate_to: localhost

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
account string | success | Account the VM is related to. Sample: example account
domain string | success | Domain the VM is related to. Sample: example domain
id string | success | UUID of the nic. Sample: 87b1e0ce-4e01-11e4-bb66-0050569e64b8
ip_address string | success | Primary IP of the NIC. Sample: 10.10.10.10
mac_address string | success | MAC address of the NIC. Sample: 02:00:33:31:00:e4
netmask string | success | Netmask of the NIC. Sample: 255.255.255.0
network string | success | Name of the network if not default. Sample: sync network
project string | success | Name of project the VM is related to. Sample: Production
vm string | success | Name of the VM. Sample: web-01

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Marc-Aurèle Brothier (@marcaurele)
- René Moser (@resmo)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.